import numpy as np

class Identity:

    def forward(self, H):
        """
        Compute identity activation function.
        
        :param H: Output from hidden or final layer.
        :return A: Output after applying activation function.
        """
        self.H = H
        return self.H

    def backward(self):
        """
        Compute derivative of identity activation function.
        
        :return dAdH: Element-wise derivative with respect to
        input to activation function H.
        """
        dAdH = np.ones(self.H.shape, dtype="f")
        return dAdH


class Sigmoid:
 
    def forward(self, H):
        """
        Compute sigmoid activation function.
        
        :param H: Output from hidden or final layer.
        :return A: Output after applying activation function.
        """
        self.H = H
        return NotImplemented

    def backward(self):
        """
        Compute derivative of identity activation function.
        
        :return dAdH: Element-wise derivative with respect to
        input to activation function H.
        """
        return NotImplemented

class Tanh:
    
    def forward(self, H):
        """
        Compute tanh activation function.
        
        :param H: Output from hidden or final layer.
        :return A: Output after applying activation function.
        """
        self.H = H
        return NotImplemented

    def backward(self):
        """
        Compute derivative of identity activation function.
        
        :return dAdH: Element-wise derivative with respect to
        input to activation function H.
        """
        return NotImplemented

class ReLU:

    def forward(self, H):
        """
        Compute tanh activation function.
        
        :param H: Output from hidden or final layer.
        :return A: Output after applying activation function.
        """
        self.H = H
        return NotImplemented

    def backward(self):
        """
        Compute derivative of identity activation function.
        
        :return dAdH: Element-wise derivative with respect to
        input to activation function H.
        """
        return NotImplemented
