import numpy as np

class MSELoss:
    
    def forward(self, O, Y):
        """
        Compute MSE loss between outputs O and true targets Y.

        :param O: Output predictions.
        :param Y: True targets.
        :return L: Mean squared error, normalized by total number
        of elements in O.
        """
        self.O = O
        self.Y = Y
        self.N = O.shape[0]
        self.q = O.shape[1]
        L = None
        return L
    
    def backward(self):
        """
        Compute gradient dLdO for MSE loss.

        :return dLdO: Gradient of loss with respect to output O.
        """
        O = self.O
        Y = self.Y
        dLdO = None
        return dLdO
    
class CrossEntropyLoss:

    def forward(self, O, Y):
        """
        Compute cross entropy loss between outputs O and true targets Y
        as well as softmax probabilities for outputs O.
        Note: Does not match PyTorch unless Y is a one-hot label matrix.

        :param O: Output predictions.
        :param Y: True targets.
        :return L: Cross entropy loss, normalized by number of examples.
        """
        self.O = O
        self.Y = Y
        self.N = O.shape[0]
        L = None
        return L

    def backward(self):
        """
        Compute gradient dLdO for cross entropy loss.

        :return dLdO: Gradient of loss with respect to output O.
        """
        dLdO = None
        return dLdO
